﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using GenerarFicheroLog;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using TarjetaAdquisicionPic;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        #region Constantes y Variables

        public const int ID_PC = 5;
        public const int FIN_TRAMA = 13;
        public const int LENG = 14;

        public const int POLLING = 8;
        public const int EVENT = 9;
        public const int STOP = 10;
        //public char id_pic, tipo, longitud;
        //public char[] datos;
        //public int contador = 0;
        //public int error;
        //public int n_sms;
        public GenerarLog ficherolog;
        public TarjetaPic DAQ;
        public bool flag_Write = true, flag_CambioEntrada = true, flag_ActualizarEstado = false;
        public byte[] puertas = new byte[8];
        public int contador_pic;
        public bool flag_EventoCambioEntrada = false;
        //int puertoremoto;
        //string ip;
        //UdpClient cliente;
        //Thread ThreadCliente;

        /**********************/
        List<Button> gates = new List<Button>();

        #endregion


        public Form1()
        {
            InitializeComponent();
            ConfigPuertos.Items.Clear();

            ficherolog = new GenerarLog("Log.txt");

            foreach (string s in SerialPort.GetPortNames())
            {
                ConfigPuertos.Items.Add(s);
            }

            ConfiguracionBps.Items.Clear();
            ConfiguracionBps.Items.Add("9600");
            ConfiguracionBps.Items.Add("14400");
            ConfiguracionBps.Items.Add("19200");
            ConfiguracionBps.Items.Add("38400");
            ConfiguracionBps.Items.Add("57600");
            ConfiguracionBps.Items.Add("115200");
            ConfiguracionBps.Items.Add("256000");

            gates.Add(PA0);
            gates.Add(PA1);
            gates.Add(PA2);
            gates.Add(PA3);
            gates.Add(PA4);
            gates.Add(PA5);
            gates.Add(null);
            gates.Add(null);

            gates.Add(PB0);
            gates.Add(PB1);
            gates.Add(PB2);
            gates.Add(PB3);
            gates.Add(PB4);
            gates.Add(PB5);
            gates.Add(PB6);
            gates.Add(PB7);

            gates.Add(PC0);
            gates.Add(PC1);
            gates.Add(PC2);
            gates.Add(PD1);
            gates.Add(PD5);
            gates.Add(PD6);
            gates.Add(PD7);
            gates.Add(null);

            gates.Add(PE0);
            gates.Add(PE1);
            gates.Add(PE2);
            gates.Add(PE3);
            gates.Add(PE4);
            gates.Add(PE5);
            gates.Add(PE6);
            gates.Add(PE7);

            gates.Add(PF0);
            gates.Add(PF1);
            gates.Add(PF2);
            gates.Add(PF3);
            gates.Add(PF4);
            gates.Add(PF5);
            gates.Add(PF6);
            gates.Add(PF7);

            gates.Add(PG0);
            gates.Add(PG1);
            gates.Add(PG2);
            gates.Add(PG3);
            gates.Add(PG4);
            gates.Add(PG5);
            gates.Add(PG6);
            gates.Add(PG7);

            gates.Add(PH0);
            gates.Add(PH1);
            gates.Add(PH2);
            gates.Add(PH3);
            gates.Add(PH4);
            gates.Add(PH5);
            gates.Add(PH6);
            gates.Add(PH7);

            gates.Add(PJ0);
            gates.Add(PJ1);
            gates.Add(PJ2);
            gates.Add(PJ3);
            gates.Add(PJ4);
            gates.Add(PJ5);
            gates.Add(PJ6);
            gates.Add(PJ7);

        }

        #region botones

        private void botonClear_Click(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
            log.Clear();
            log.AppendText("Fecha / Hora                             DATOS					Contador");
        }

        #endregion    

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ficherolog.close();
            if(DAQ!=null){
                if (ConectarPic.Text == "Desconectar PIC")
                {
                    DAQ.Desconectar();
                }
            }
        }

        #region FuncionesCambioModo

        private void radioEvent_Click(object sender, EventArgs e)
        {

            byte umb = Convert.ToByte(umbral.Text);
            int muestra = 1 + muestreo.SelectedIndex;
            int keep = Convert.ToInt32(keepalive.Text);
            if (radioEvent.Checked)
            {
                radioPolling.Enabled = false;
            }
            DAQ.EstablecerModo(EVENT, umb, muestra, keep);
        }

        private void radioPolling_Click(object sender, EventArgs e)
        {
            byte umb = Convert.ToByte(umbral.Text);
            int muestra = 1 + muestreo.SelectedIndex;
            int keep = Convert.ToInt32(keepalive.Text);
            if (radioPolling.Checked)
            {
                radioEvent.Enabled = false;
            }
            DAQ.EstablecerModo(POLLING, umb, muestra, keep);
        }

        private void radioStop_Click(object sender, EventArgs e)
        {
            byte umb = Convert.ToByte(umbral.Text);
            int muestra = 1 + muestreo.SelectedIndex;
            int keep = Convert.ToInt32(keepalive.Text);
            if (radioStop.Checked)
            {
                radioPolling.Enabled = true;
                radioEvent.Enabled = true;
            }
            DAQ.EstablecerModo(STOP, umb, muestra, keep);
        }

        private byte temporizador(string p)
        {
            switch (p)
            {
                case "10,4 ms":
                    return 1;
                case "20,9 ms":
                    return 2;
                case "41,9 ms":
                    return 3;
                case "83,8 ms":
                    return 4;
                default:
                    return 0;
            }
        }

        #endregion


        private void botonEstablecerModo_Click(object sender, EventArgs e)
        {
            byte[] ip = new byte[8];
            byte idPic;
            int velocidad;
            if (ConfigPuertos.Text != "Puerto COM")
            {
                if (ModoRed.Checked) // Modo Red
                {
                    if (identPIC.Text != "")
                    {
                        idPic = Convert.ToByte(identPIC.Text);       // Establecemos un ID para el PIC, por defecto 8
                    }
                    else
                    {
                        idPic = 0;
                    }

                    if (ConfiguracionIP.Checked)                        // Establecemos la IP
                    {
                        ip[0] = Convert.ToByte(ConfigIp1.Text);
                        ip[1] = Convert.ToByte(ConfigIp2.Text);
                        ip[2] = Convert.ToByte(ConfigIp3.Text);
                        ip[3] = Convert.ToByte(ConfigIp4.Text);
                        ip[4] = Convert.ToByte(ConfigNetmask1.Text);
                        ip[5] = Convert.ToByte(ConfigNetmask2.Text);
                        ip[6] = Convert.ToByte(ConfigNetmask3.Text);
                        ip[7] = Convert.ToByte(ConfigNetmask4.Text);
                        DAQ = new TarjetaPic(ConfigPuertos.Text, ip, idPic, ID_PC);

                    }
                    else
                    {
                        DAQ = new TarjetaPic(ConfigPuertos.Text, idPic, ID_PC);
                    }
                }
                else if (ModoSerie.Checked)
                {
                    if (identPIC.Text != "")
                    {
                        idPic = Convert.ToByte(identPIC.Text);       // Establecemos un ID para el PIC, por defecto 8
                    }
                    else
                    {
                        idPic = 0;
                    }
                    velocidad = Convert.ToInt32(ConfiguracionBps.Text);
                    DAQ = new TarjetaPic(ConfigPuertos.Text, velocidad, idPic, ID_PC);
                }

            }
            else
            {
                MessageBox.Show("Selecciona el Puerto COM para la configuración de la Placa", "Información",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void ConfiguracionIP_CheckedChanged(object sender, EventArgs e)
        {
            if (ConfiguracionIP.Checked)
            {
                grupoIPFija.Enabled = true;
            }
            else
            {
                grupoIPFija.Enabled = false;
            }


        }

        private void ConectarPic_Click(object sender, EventArgs e)
        {
            if (ConectarPic.Text == "Conectar PIC")
            {
                

                try
                {
                    DAQ.Conectar();
                    grupoEcho.Enabled = true;
                    grupoEstado.Enabled = true;
                    grupoMedio.Enabled = true;
                    ConectarPic.Text = "Desconectar PIC";
                    DAQ.EventoCambioEntradas += new TarjetaPic.manejadorEventoCambioEntradas(DAQ_EventoCambioEntradas);
                    ficherolog.write("\n" + "Inicio de la actividad" + DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss") + "\n");


                }
                catch
                {
                    MessageBox.Show("No se ha establecido medio", "Información", MessageBoxButtons.OK,
                                    MessageBoxIcon.Error);
                }
            }
            else if (ConectarPic.Text == "Desconectar PIC")
            {
                try
                {
                    DAQ.Desconectar();
                    grupoEcho.Enabled = false;
                    grupoEstado.Enabled = false;
                    grupoMedio.Enabled = false;
                    ConectarPic.Text = "Conectar PIC";
                    DAQ.EventoCambioEntradas -= new TarjetaPic.manejadorEventoCambioEntradas(DAQ_EventoCambioEntradas);
                }
                catch
                {
                    MessageBox.Show("No se ha establecido medio", "Información", MessageBoxButtons.OK,
                                    MessageBoxIcon.Error);
                }
            }

        }

        private void BotonEco_Click(object sender, EventArgs e)
        {
            DAQ.enviarEcho();
            DAQ.EventoRespuestaEco += new TarjetaPic.manejadorEventoRespuestaEco(manejadorEventoEcho);
        }

        private void manejadorEventoEcho(bool eco)
        {
            if (eco)
            {
                this.Invoke(new EventHandler(MostarEcho));
            }
        }

        public void MostarEcho(object s, EventArgs e) { textbox_eco.Text = "ACK_ECHO"; }

        #region FuncionesBotonesSalidas

        private void PA0_Click(object sender, EventArgs e)
        {
            if (PA0.Text == "OFF")
            {
                DAQ.setSalida(0, true);
            }
            else
            {
                DAQ.setSalida(0, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PA0);
        }

        private void PA1_Click(object sender, EventArgs e)
        {
            if (PA1.Text == "OFF")
            {
                DAQ.setSalida(1, true);
            }
            else
            {
                DAQ.setSalida(1, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PA1);
        }

        private void PA2_Click(object sender, EventArgs e)
        {
            if (PA2.Text == "OFF")
            {
                DAQ.setSalida(2, true);
            }
            else
            {
                DAQ.setSalida(2, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);

            cambio(PA2);
        }

        private void PA3_Click(object sender, EventArgs e)
        {
            if (PA3.Text == "OFF")
            {
                DAQ.setSalida(3, true);
            }
            else
            {
                DAQ.setSalida(3, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PA3);
        }

        private void PA4_Click(object sender, EventArgs e)
        {
            if (PA4.Text == "OFF")
            {
                DAQ.setSalida(4, true);
            }
            else
            {
                DAQ.setSalida(4, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PA4);
        }

        private void PA5_Click(object sender, EventArgs e)
        {
            if (PA5.Text == "OFF")
            {
                DAQ.setSalida(5, true);
            }
            else
            {
                DAQ.setSalida(5, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PA5);
        }

        private void PE0_Click(object sender, EventArgs e)
        {
            if (PE0.Text == "OFF")
            {
                DAQ.setSalida(8, true);
            }
            else
            {
                DAQ.setSalida(8, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE0);
        }

        private void PE1_Click(object sender, EventArgs e)
        {
            if (PE1.Text == "OFF")
            {
                DAQ.setSalida(9, true);
            }
            else
            {
                DAQ.setSalida(9, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE1);
        }

        private void PE2_Click(object sender, EventArgs e)
        {
            if (PE2.Text == "OFF")
            {
                DAQ.setSalida(10, true);
            }
            else
            {
                DAQ.setSalida(10, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE2);
        }

        private void PE3_Click(object sender, EventArgs e)
        {
            if (PE3.Text == "OFF")
            {
                DAQ.setSalida(11, true);
            }
            else
            {
                DAQ.setSalida(11, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE3);
        }

        private void PE4_Click(object sender, EventArgs e)
        {
            if (PE4.Text == "OFF")
            {
                DAQ.setSalida(12, true);
            }
            else
            {
                DAQ.setSalida(12, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE4);
        }

        private void PE5_Click(object sender, EventArgs e)
        {
            if (PE5.Text == "OFF")
            {
                DAQ.setSalida(13, true);
            }
            else
            {
                DAQ.setSalida(13, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE5);
        }

        private void PE6_Click(object sender, EventArgs e)
        {
            if (PE6.Text == "OFF")
            {
                DAQ.setSalida(14, true);
            }
            else
            {
                DAQ.setSalida(14, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE6);
        }

        private void PE7_Click(object sender, EventArgs e)
        {
            if (PE7.Text == "OFF")
            {
                DAQ.setSalida(15, true);
            }
            else
            {
                DAQ.setSalida(15, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PE7);
        }

        private void PH0_Click(object sender, EventArgs e)
        {
            if (PH0.Text == "OFF")
            {
                DAQ.setSalida(16, true);
            }
            else
            {
                DAQ.setSalida(16, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH0);
        }

        private void PH1_Click(object sender, EventArgs e)
        {
            if (PH1.Text == "OFF")
            {
                DAQ.setSalida(17, true);
            }
            else
            {
                DAQ.setSalida(17, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH1);
        }

        private void PH2_Click(object sender, EventArgs e)
        {
            if (PH2.Text == "OFF")
            {
                DAQ.setSalida(18, true);
            }
            else
            {
                DAQ.setSalida(18, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH2);
        }

        private void PH3_Click(object sender, EventArgs e)
        {
            if (PH3.Text == "OFF")
            {
                DAQ.setSalida(19, true);
            }
            else
            {
                DAQ.setSalida(19, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH3);
        }

        private void PH4_Click(object sender, EventArgs e)
        {
            if (PH4.Text == "OFF")
            {
                DAQ.setSalida(20, true);
            }
            else
            {
                DAQ.setSalida(20, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH4);
        }

        private void PH5_Click(object sender, EventArgs e)
        {
            if (PH5.Text == "OFF")
            {
                DAQ.setSalida(21, true);
            }
            else
            {
                DAQ.setSalida(21, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH5);
        }

        private void PH6_Click(object sender, EventArgs e)
        {
            if (PH6.Text == "OFF")
            {
                DAQ.setSalida(22, true);
            }
            else
            {
                DAQ.setSalida(22, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH6);
        }

        private void PH7_Click(object sender, EventArgs e)
        {
            if (PH7.Text == "OFF")
            {
                DAQ.setSalida(23, true);
            }
            else
            {
                DAQ.setSalida(23, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PH7);
        }

        private void PJ0_Click(object sender, EventArgs e)
        {
            if (PJ0.Text == "OFF")
            {
                DAQ.setSalida(24, true);
            }
            else
            {
                DAQ.setSalida(24, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ0);
        }

        private void PJ1_Click(object sender, EventArgs e)
        {
            if (PJ1.Text == "OFF")
            {
                DAQ.setSalida(25, true);
            }
            else
            {
                DAQ.setSalida(25, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ1);
        }

        private void PJ2_Click(object sender, EventArgs e)
        {
            if (PJ2.Text == "OFF")
            {
                DAQ.setSalida(26, true);
            }
            else
            {
                DAQ.setSalida(26, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ2);
        }

        private void PJ3_Click(object sender, EventArgs e)
        {
            if (PJ3.Text == "OFF")
            {
                DAQ.setSalida(27, true);
            }
            else
            {
                DAQ.setSalida(27, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ3);
        }

        private void PJ4_Click(object sender, EventArgs e)
        {
            if (PJ4.Text == "OFF")
            {
                DAQ.setSalida(28, true);
            }
            else
            {
                DAQ.setSalida(28, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ4);
        }

        private void PJ5_Click(object sender, EventArgs e)
        {
            if (PJ5.Text == "OFF")
            {
                DAQ.setSalida(29, true);
            }
            else
            {
                DAQ.setSalida(29, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ5);
        }

        private void PJ6_Click(object sender, EventArgs e)
        {
            if (PJ6.Text == "OFF")
            {
                DAQ.setSalida(30, true);
            }
            else
            {
                DAQ.setSalida(30, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ6);
        }

        private void PJ7_Click(object sender, EventArgs e)
        {
            if (PJ7.Text == "OFF")
            {
                DAQ.setSalida(31, true);
            }
            else
            {
                DAQ.setSalida(31, false);
            }
            DAQ.EventoRespuestaWriteOne += new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            DAQ.EventoRespuestaNoWriteOne += new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
            cambio(PJ7);
        }

        #endregion

        private void cambio(Button boton)
        {
            if (flag_Write)
            {
                flag_Write = false;
                if (boton.Text == "OFF")
                {
                    boton.BackColor = Color.GreenYellow;
                    boton.Text = "ON";
                }
                else
                {
                    boton.BackColor = Color.Red;
                    boton.Text = "OFF";
                }
            }
        }

        private void DAQ_EventoRespuestaNoWriteOne(bool flag_NoWriteOne)
        {
            if (flag_NoWriteOne)
            {
                this.Invoke(new EventHandler(MostrarNoWriteOne));
                DAQ.EventoRespuestaNoWriteOne -= new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
                DAQ.EventoRespuestaWriteOne -= new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
            }
        }

        private void MostrarNoWriteOne(object sender, EventArgs e)
        {
            log.AppendText("\nEl envio de cambio de estado de puertas no ha sido satisfactorio.\n");
        }
        
        private void DAQ_EventoRespuestaWriteOne(bool flag)
        {
            if (flag == true)
            {
                DAQ.EventoRespuestaWriteOne -= new TarjetaPic.manejadorEventoRespuestaWriteOne(DAQ_EventoRespuestaWriteOne);
                DAQ.EventoRespuestaNoWriteOne -= new TarjetaPic.manejadorEventoRespuestaNoWriteOne(DAQ_EventoRespuestaNoWriteOne);
                flag_Write = true;
            }
        }

        private void ModoSerie_Click(object sender, EventArgs e)
        {
            grupoVelocidad.Enabled = true;
            grupoIP.Enabled = false;
        }

        private void ModoRed_Click(object sender, EventArgs e)
        {
            grupoVelocidad.Enabled = false;
            grupoIP.Enabled = true;
        }

        private void ActualizarEstado_Click(object sender, EventArgs e)
        {
            try
            {
                DAQ.enviarRead();
            }
            catch
            {
                MessageBox.Show("Medio no establecido", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void DAQ_EventoCambioEntradas(byte[] entradas, int secuencia)
        {
            entradas.CopyTo(puertas, 0);
            contador_pic = secuencia;
            flag_CambioEntrada = true;
            this.Invoke(new EventHandler(MostrarLog));
            this.Invoke(new EventHandler(UpdateButtons));

        }


        private void MostrarLog(object e, EventArgs ea)
        {
            byte[] fin = new byte[1];
            string packet = "\n" + DateTime.Now.ToString("dd/MM/yyyy  HH:mm:ss") + "  ";

            for (int i = 0; i < 8; i++)
            {
                fin[0] = puertas[i];
                packet += " " + DAQ.DecimaltoBinaryString(fin);
            }
            packet += "  " + contador_pic;
            ficherolog.write(packet);
            log.AppendText(packet);
            puertas.Initialize();
        }

        private void UpdateButtons(object e, EventArgs ev)
        {
            BitArray inPut = new BitArray(puertas);
            int i = 0;
            foreach (Button bt in gates)
            {
                if (bt != null)
                {

                    if (inPut[i] && bt.Text == "OFF")
                    {
                        bt.BackColor = Color.GreenYellow;
                        bt.Text = "ON";
                    }
                    else if (!inPut[i] && bt.Text == "ON")
                    {
                        bt.BackColor = Color.Red;
                        bt.Text = "OFF";
                    }
                }
                i++;
            }
        }           
    

        private void button1_Click(object sender, EventArgs e)
        {
            DAQ.EstablecerMedio();
        }
    }
}


